package stdlib

import (
	"surdeus.su/core/xgo/v2"
	"surdeus.su/core/xgo/v2/stdlib/http"
	"surdeus.su/core/xgo/v2/stdlib/paths"
	"surdeus.su/core/xgo/v2/stdlib/html"
	"surdeus.su/core/xgo/v2/stdlib/log"
	"surdeus.su/core/xgo/v2/stdlib/cjson"
)

// BuiltinModules are builtin type standard library modules.
var BuiltinModules = map[string]map[string]xgo.Object{
	"math":   mathModule,
	"os":     osModule,
	"text":   textModule,
	"times":  timesModule,
	"rand":   randModule,
	"fmt":    fmtModule,
	"json":   jsonModule,
	"base64": base64Module,
	"hex":    hexModule,
	// Implement later.
	"url":   nil,
	"http":  http.Module,
	"paths": paths.Module,
	"html":  html.Module,
	"log":   log.Module,
	"cjson": cjson.Module,
}
