package http

import (
	"surdeus.su/core/xgo/v2"
	"net/http"
	"io"
	//"log"
	xurl "surdeus.su/core/xgo/v2/stdlib/url"
)

type Request struct {
	*http.Request
	xgo.ObjectImpl
}

func (r *Request) TypeName() string {
	return "http.Request"
}

func (r *Request) String() string {
	return "http.Request{...}"
}

func (r *Request) IndexGet(
	index xgo.Object,
) (xgo.Object, error) {
	key, ok := xgo.ToString(index)
	if !ok {
		return nil, xgo.ErrInvalidIndexValueType
	}

	switch key {
	case "url":
		return &xurl.URL{
			URL: r.URL,
		}, nil
	case "body":
		bts, err := io.ReadAll(r.Body)
		if err != nil {
			return nil, err
		}
		return &xgo.Bytes{
			Value: bts,
		}, nil
	}

	// Nothing found.
	return nil, nil
}
