package http

import "net/http"
import "surdeus.su/core/xgo/v2"
import "io"
import tjson "surdeus.su/core/xgo/v2/stdlib/json"

type Response struct {
	*http.Response
	xgo.ObjectImpl
}

func (r *Response) TypeName() string {
	return "http.Response"
}

func (r *Response) String() string {
	return "http.Response{...}"
}

func (r *Response) IndexGet(
	index xgo.Object,
) (xgo.Object, error) {
	key, ok := xgo.ToString(index)
	if !ok {
		return nil, xgo.ErrInvalidIndexValueType
	}

	switch key {
	case "body":
		bts, err := io.ReadAll(r.Body)
		if err != nil {
			return nil, err
		}
		return &xgo.Bytes{
			Value: bts,
		}, nil
	case "body_json":
		bts, err := io.ReadAll(r.Body)
		if err != nil {
			return nil, err
		}

		return tjson.Decode(bts)
	}

	// Nothing found.
	return nil, nil
}
