package log

import "surdeus.su/core/xgo/v2"
import "log"

var Module = map[string]xgo.Object{
	"printf": &xgo.BuiltinFunction{
		Name: "printf",
		Value: func(
			args ...xgo.Object,
		) (xgo.Object, error) {
			if len(args) < 1 {
				return nil, xgo.ErrWrongNumArguments
			}

			formatObject := args[0]
			format, hasFormat := xgo.ToString(
				formatObject,
			)
			if !hasFormat {
				return nil, xgo.ErrInvalidArgumentType{
					Name:     "first",
					Expected: "string",
					Found:    formatObject.TypeName(),
				}
			}

			/*v := make([]any, len(args[1:]))
			for i, o := range args[1:] {
				v[i] = xgo.ToInterface(o)
			}*/

			str, err := xgo.Format(format, args...)
			if err != nil {
				return nil, err
			}
			log.Print(str)

			return nil, nil
		},
	},
	"print": &xgo.BuiltinFunction{
		Name: "print",
		Value: func(
			args ...xgo.Object,
		) (xgo.Object, error) {
			v := make([]any, len(args))
			for i, o := range args {
				var ok bool
				v[i], ok = xgo.ToString(o)
				if !ok {
					v[i] = xgo.Undefined{}
				}
			}
			log.Print(v...)
			return nil, nil
		},
	},
	"println": &xgo.BuiltinFunction{
		Name: "println",
		Value: func(
			args ...xgo.Object,
		) (xgo.Object, error) {
			v := make([]any, len(args))
			for i, o := range args {
				var ok bool
				v[i], ok = xgo.ToString(o)
				if !ok {
					v[i] = xgo.Undefined{}
				}
			}
			log.Println(v...)
			return nil, nil
		},
	},
}
